package simulator.stats.implementation;

import java.util.Map;
import java.util.TreeMap;

import schedframe.resources.ResourceType;
import simulator.stats.implementation.out.StatsSerializer;

public class ResourceAirFlowStats {
	protected Map<Long, Double> airFlow;
	protected String resourceName;
	protected String usageType;
	protected ResourceType resourceType;
	protected double meanValue;
	protected double sumValue;
	
	public void setSumUsage(double sumUsage) {
		this.sumValue = sumUsage;
	}

	public double getSumUsage() {
		return sumValue;
	}
	public void setMeanUsage(double meanUsage) {
		this.meanValue = meanUsage;
	}
	
	public double getMeanUsage() {
		return meanValue;
	}
	
	private String[] headers = { "resourceName", "timestamp", "value" };
	
	public ResourceAirFlowStats (String resourceName, ResourceType resourceType, String usageType) {
		this.resourceName = resourceName;
		this.resourceType = resourceType;
		this.usageType = usageType;
		this.airFlow = new TreeMap<Long, Double>();
		this.meanValue = 0;
	}

	public String getResourceName() {
		return this.resourceName;
	}
	
	public ResourceType getResourceType() {
		return resourceType;
	}

	public String getUsageType() {
		return this.usageType;
	}	

	public Map<Long, Double> getAirFlow() {
		return this.airFlow;
	}

	public Object serialize(StatsSerializer serializer) {
		return serializer.visit(this);
	}

	public String[] getHeaders() {
		return headers;
	}

}
