package simulator.stats.implementation;

import java.util.Map;
import java.util.TreeMap;

import schedframe.resources.ResourceType;
import schedframe.resources.StandardResourceType;
import simulator.stats.implementation.out.StatsSerializer;

/**
 * 
 * @author Marcin Krystek
 * 
 */
public class ResourceUsageStats implements StatsInterface {

	protected Map<Long, Double> usage;
	protected String resourceName;
	protected String usageType;
	protected ResourceType resourceType;
	protected double meanUsage;
	
	public void setMeanUsage(double meanUsage) {
		this.meanUsage = meanUsage;
	}

	private String[] headers = { "resourceName", "timestamp", "usage" };

	public ResourceUsageStats(String resourceName, ResourceType resourceType, String usageType) {
		this.resourceName = resourceName;
		this.resourceType = resourceType;
		this.usageType = usageType;
		this.usage = new TreeMap<Long, Double>();
		this.meanUsage = 0;
	}

	public double getMeanUsage() {
		return meanUsage;
	}

	public String getResourceName() {
		return this.resourceName;
	}
	
	public ResourceType getResourceType() {
		return resourceType;
	}
	
	public String getUsageType() {
		return this.usageType;
	}	

	public Map<Long, Double> getUsage() {
		return this.usage;
	}

	public Object serialize(StatsSerializer serializer) {
		return serializer.visit(this);
	}

	public String[] getHeaders() {
		return headers;
	}

}
